=== binder/requirements.txt ===
ortools
matplotlib
plotly
svgwrite
