=== debian/changelog ===
ortools (8.2+ds-6) unstable; urgency=medium

  [ Thomas Vincent ]
  * d/control: Fix typo in libortools-doc description

  [ Agathe Porte ]
  * fix FTBFS with gcc12 (Closes: #1013013)

 -- Agathe Porte <debian@microjoe.org>  Sun, 31 Jul 2022 22:11:30 +0200

ortools (8.2+ds-5) unstable; urgency=medium

  * d/rules: remove boilerplate comments
  * d/control: add missing dep python3-protobuf

 -- Agathe Porte <debian@microjoe.org>  Tue, 24 May 2022 14:48:38 +0200

ortools (8.2+ds-4) unstable; urgency=medium

  * d/control: Fix bad Vcs-Git and Vcs-Browser

 -- Agathe Porte <debian@microjoe.org>  Sat, 05 Mar 2022 13:50:17 +0100

ortools (8.2+ds-3) unstable; urgency=medium

  * d/rules: fix build error on "any" arch

 -- Agathe Porte <debian@microjoe.org>  Tue, 01 Mar 2022 14:33:39 +0100

ortools (8.2+ds-2) unstable; urgency=medium

  * patch: drop references to removed absl::container target
  * Move samples in /usr/lib instead of /usr/bin (Closes: #1005773)

 -- Agathe Porte <debian@microjoe.org>  Sat, 26 Feb 2022 12:00:30 +0100

ortools (8.2+ds-1) unstable; urgency=medium

  * Initial release. (Closes: #985094)

 -- Agathe Porte <debian@microjoe.org>  Tue, 25 Jan 2022 23:43:41 +0100
