=== debian/watch ===
version=4
opts=dversionmangle=s/\+(debian|dfsg|ds|deb)(\.?\d+)?$//,\
  repacksuffix=+ds \
  https://github.com/google/or-tools/tags .*/v?(\d\S+)\.tar\.gz
